const path = require('path');
const server_config = path.resolve(_flitter.directories.config, 'server.config.js')
const example_env = path.resolve(_flitter.root, 'example.env')
const docker_env = path.resolve(_flitter.root, 'docker.env')

exports.up = async ({flap}) => {
	const config_def_end = /(?:\n*)}(?:\n|\s)*(?:module.)?exports\s*=\s*(?:(?:module.)?exports\s*=\s*)?/

	await flap.find_replace_file(server_config, config_def_end, `,

	ssl: {
        enable: (process.env.SSL_ENABLE ? (process.env.SSL_ENABLE === 'true') : false),

        /*
         * Path to your domain's certificate file.
         * This should contain any intermediate certificates as well.
         */
        cert_file: process.env.SSL_CERT_FILE || 'cert.pem',

        /*
         * Path to your domain's certificate key.
         */
        key_file: process.env.SSL_KEY_FILE || 'cert.key',
    }, %orig`)

	await flap.insert_line(example_env, /ENVIRONMENT=(?:.)*/, `
SSL_ENABLE=false
SSL_CERT_FILE=cert.pem
SSL_CERT_KEY=cert.key`)

	await flap.insert_line(docker_env, /ENVIRONMENT=(?:.)*/, `
SSL_ENABLE=false
SSL_CERT_FILE=cert.pem
SSL_CERT_KEY=cert.key`)

}

exports.down = async ({flap}) => {

	const ssl_block = /,(?:\s|\n)*ssl:\s*{(?:(?:(?:\n|\s|[a-zA-Z_'"])*:.*?,(?:\s|\n)*)|(?:\/\*(?:.|\n)*?\*\/))*},(?:\s|\n)*/

	await flap.find_replace_file(server_config, ssl_block, '')

	await flap.delete_line(example_env, /SSL_(?:.)*/)
	await flap.delete_line(example_env, /SSL_(?:.)*/)
	await flap.delete_line(example_env, /SSL_(?:.)*/)
	await flap.delete_line(docker_env, /SSL_(?:.)*/)
	await flap.delete_line(docker_env, /SSL_(?:.)*/)
	await flap.delete_line(docker_env, /SSL_(?:.)*/)

}